diff -caPr ..\vimorg/src/configure.in ./src/configure.in
*** ..\vimorg/src/configure.in	2010-04-19 14:14:44.346457100 +0200
--- ./src/configure.in	2010-04-19 17:39:53.391848200 +0200
***************
*** 826,831 ****
--- 826,832 ----
      fi
    fi
  fi
+ 
  AC_SUBST(PYTHON_CONFDIR)
  AC_SUBST(PYTHON_LIBS)
  AC_SUBST(PYTHON_GETPATH_CFLAGS)
***************
*** 833,838 ****
--- 834,1015 ----
  AC_SUBST(PYTHON_SRC)
  AC_SUBST(PYTHON_OBJ)
  
+ 
+ AC_MSG_CHECKING(--enable-python3interp argument)
+ AC_ARG_ENABLE(python3interp,
+ 	[  --enable-python3interp   Include Python3 interpreter.], ,
+ 	[enable_python3interp="no"])
+ AC_MSG_RESULT($enable_python3interp)
+ if test "$enable_python3interp" = "yes"; then
+   dnl -- find the python3 executable
+   AC_PATH_PROG(vi_cv_path_python3, python3)
+   if test "X$vi_cv_path_python3" != "X"; then
+ 
+     dnl -- get its version number
+     AC_CACHE_CHECK(Python version,vi_cv_var_python3_version,
+     [[vi_cv_var_python3_version=`
+           ${vi_cv_path_python3} -c 'import sys; print(sys.version[1:3])'`
+     ]])
+ 
+     dnl -- find where python3 thinks it was installed
+     AC_CACHE_CHECK(Python's install prefix,vi_cv_path_python3_pfx,
+     [ vi_cv_path_python3_pfx=`
+      ${vi_cv_path_python3} -c \
+      "import sys; print(sys.prefix)"` ])
+ 
+     dnl -- and where it thinks it runs
+     AC_CACHE_CHECK(Python's execution prefix,vi_cv_path_python3_epfx,
+     [ vi_cv_path_python3_epfx=`
+      ${vi_cv_path_python3} -c \
+      "import sys; print(sys.exec_prefix)"` ])
+ 
+     dnl -- python3's internal library path
+ 
+     AC_CACHE_VAL(vi_cv_path_python3path,
+     [ vi_cv_path_python3path=`
+      unset PYTHONPATH;
+      ${vi_cv_path_python3} -c \
+      "import sys, string; print(':'.join(sys.path))"` ])
+ 
+     dnl -- where the Python implementation library archives are
+ 
+     AC_ARG_WITH(python3-config-dir,
+      [  --with-python3-config-dir=PATH  Python's config directory],
+      [ vi_cv_path_python3_conf="${withval}" ] )
+ 
+     AC_CACHE_CHECK(Python's configuration directory,vi_cv_path_python3_conf,
+     [
+      vi_cv_path_python3_conf=
+      for path in "${vi_cv_path_python3_pfx}" "${vi_cv_path_python3_epfx}"; do
+        for subdir in lib share; do
+          d="${path}/${subdir}/python3${vi_cv_var_python3_version}/config"
+          if test -d "$d" && test -f "$d/config.c"; then
+            vi_cv_path_python3_conf="$d"
+          fi
+        done
+      done
+     ])
+ 
+     PYTHON3_CONFDIR="${vi_cv_path_python3_conf}"
+ 
+     if test "X$PYTHON3_CONFDIR" = "X"; then
+       AC_MSG_RESULT([can't find it!])
+     else
+ 
+       dnl -- we need to examine Python's config/Makefile too
+       dnl    see what the interpreter is built from
+       AC_CACHE_VAL(vi_cv_path_python3_plibs,
+       [
+           pwd=`pwd`
+           tmp_mkf="$pwd/config-PyMake$$"
+           cat -- "${PYTHON3_CONFDIR}/Makefile" - <<'eof' >"${tmp_mkf}"
+ __:
+ 	@echo "python3_MODLIBS='$(MODLIBS)'"
+ 	@echo "python3_LIBS='$(LIBS)'"
+ 	@echo "python3_SYSLIBS='$(SYSLIBS)'"
+ 	@echo "python3_LINKFORSHARED='$(LINKFORSHARED)'"
+ eof
+           dnl -- delete the lines from make about Entering/Leaving directory
+           eval "`cd ${PYTHON3_CONFDIR} && make -f "${tmp_mkf}" __ | sed '/ directory /d'`"
+           rm -f -- "${tmp_mkf}"
+           vi_cv_path_python3_plibs="-L${PYTHON3_CONFDIR} -lpython3${vi_cv_var_python3_version}"
+           vi_cv_path_python3_plibs="${vi_cv_path_python3_plibs} ${python3_MODLIBS} ${python3_LIBS} ${python3_SYSLIBS} ${python3_LINKFORSHARED}"
+           dnl remove -ltermcap, it can conflict with an earlier -lncurses
+           vi_cv_path_python3_plibs=`echo $vi_cv_path_python3_plibs | sed s/-ltermcap//`
+       ])
+ 
+       PYTHON3_LIBS="${vi_cv_path_python3_plibs}"
+       if test "${vi_cv_path_python3_pfx}" = "${vi_cv_path_python3_epfx}"; then
+         PYTHON3_CFLAGS="-I${vi_cv_path_python3_pfx}/include/python3${vi_cv_var_python3_version}"
+       else
+         PYTHON3_CFLAGS="-I${vi_cv_path_python3_pfx}/include/python3${vi_cv_var_python3_version} -I${vi_cv_path_python3_epfx}/include/python3${vi_cv_var_python3_version}"
+       fi
+       PYTHON3_SRC="if_python3.c"
+       dnl For Mac OSX 10.2 config.o is included in the Python library.
+       if test "x$MACOSX" = "xyes"; then
+         PYTHON3_OBJ="objects/if_python3.o"
+       else
+         PYTHON3_OBJ="objects/if_python3.o objects/py3_config.o"
+       fi
+ 
+       dnl On FreeBSD linking with "-pthread" is required to use threads.
+       dnl _THREAD_SAFE must be used for compiling then.
+       dnl The "-pthread" is added to $LIBS, so that the following check for
+       dnl sigaltstack() will look in libc_r (it's there in libc!).
+       dnl Otherwise, when using GCC, try adding -pthread to $CFLAGS.  GCC
+       dnl will then define target-specific defines, e.g., -D_REENTRANT.
+       dnl Don't do this for Mac OSX, -pthread will generate a warning.
+       AC_MSG_CHECKING([if -pthread should be used])
+       threadsafe_flag=
+       thread_lib=
+       dnl if test "x$MACOSX" != "xyes"; then
+       if test "`(uname) 2>/dev/null`" != Darwin; then
+         test "$GCC" = yes && threadsafe_flag="-pthread"
+         if test "`(uname) 2>/dev/null`" = FreeBSD; then
+           threadsafe_flag="-D_THREAD_SAFE"
+           thread_lib="-pthread"
+         fi
+       fi
+       libs_save_old=$LIBS
+       if test -n "$threadsafe_flag"; then
+         cflags_save=$CFLAGS
+         CFLAGS="$CFLAGS $threadsafe_flag"
+         LIBS="$LIBS $thread_lib"
+         AC_TRY_LINK(,[ ],
+            AC_MSG_RESULT(yes); PYTHON3_CFLAGS="$PYTHON3_CFLAGS $threadsafe_flag",
+            AC_MSG_RESULT(no); LIBS=$libs_save_old
+            )
+         CFLAGS=$cflags_save
+       else
+         AC_MSG_RESULT(no)
+       fi
+ 
+       dnl check that compiling a simple program still works with the flags
+       dnl added for Python.
+       AC_MSG_CHECKING([if compile and link flags for Python are sane])
+       cflags_save=$CFLAGS
+       libs_save=$LIBS
+       CFLAGS="$CFLAGS $PYTHON3_CFLAGS"
+       LIBS="$LIBS $PYTHON3_LIBS"
+       AC_TRY_LINK(,[ ],
+              AC_MSG_RESULT(yes); python3_ok=yes,
+              AC_MSG_RESULT(no: PYTHON3 DISABLED); python3_ok=no)
+       CFLAGS=$cflags_save
+       LIBS=$libs_save
+       if test $python3_ok = yes; then
+         AC_DEFINE(FEAT_PYTHON3)
+       else
+         LIBS=$libs_save_old
+         PYTHON3_SRC=
+         PYTHON3_OBJ=
+         PYTHON3_LIBS=
+         PYTHON3_CFLAGS=
+       fi
+     fi
+   fi
+ fi
+ 
+ AC_SUBST(PYTHON3_CONFDIR)
+ AC_SUBST(PYTHON3_LIBS)
+ AC_SUBST(PYTHON3_CFLAGS)
+ AC_SUBST(PYTHON3_SRC)
+ AC_SUBST(PYTHON3_OBJ)
+ 
+ dnl if python2.x and python3.x are enabled one can only link in code
+ dnl with dlopen(), dlsym(), dlclose() 
+ if test $python_ok = yes && test $python3_ok = yes; then
+   AC_DEFINE(DYNAMIC_PYTHON)
+   AC_DEFINE(DYNAMIC_PYTHON3)
+   PYTHON_SRC="if_python.c"
+   PYTHON_OBJ="objects/if_python.o"
+   PYTHON_CFLAGS="$PYTHON_CFLAGS -DDYNAMIC_PYTHON_DLL=\\\"libpython${vi_cv_var_python_version}.so\\\""
+   PYTHON_LIBS=
+   PYTHON3_SRC="if_python3.c"
+   PYTHON3_OBJ="objects/if_python3.o"
+   PYTHON3_CFLAGS="$PYTHON3_CFLAGS -DDYNAMIC_PYTHON3_DLL=\\\"libpython3${vi_cv_var_python3_version}.so\\\""
+   PYTHON3_LIBS=
+ fi
+ 
  AC_MSG_CHECKING(--enable-tclinterp argument)
  AC_ARG_ENABLE(tclinterp,
  	[  --enable-tclinterp      Include Tcl interpreter.], ,
diff -caPr ..\vimorg/src/eval.c ./src/eval.c
*** ..\vimorg/src/eval.c	2010-04-19 14:14:44.690044300 +0200
--- ./src/eval.c	2010-04-19 18:24:52.512228200 +0200
***************
*** 5872,5879 ****
      return item1 == NULL && item2 == NULL;
  }
  
! #if defined(FEAT_RUBY) || defined(FEAT_PYTHON) || defined(FEAT_MZSCHEME) \
! 	|| defined(PROTO)
  /*
   * Return the dictitem that an entry in a hashtable points to.
   */
--- 5872,5878 ----
      return item1 == NULL && item2 == NULL;
  }
  
! #if defined(FEAT_PYTHON) || defined(FEAT_PYTHON3) || defined(FEAT_MZSCHEME) || defined(PROTO) || defined(PROTO)
  /*
   * Return the dictitem that an entry in a hashtable points to.
   */
***************
*** 11706,11711 ****
--- 11705,11715 ----
  	"python",
  #endif
  #endif
+ #ifdef FEAT_PYTHON3
+ #ifndef DYNAMIC_PYTHON3
+ 	"python3",
+ #endif
+ #endif
  #ifdef FEAT_POSTSCRIPT
  	"postscript",
  #endif
***************
*** 11895,11904 ****
--- 11899,11916 ----
  	else if (STRICMP(name, "ruby") == 0)
  	    n = ruby_enabled(FALSE);
  #endif
+ #ifdef FEAT_PYTHON
  #ifdef DYNAMIC_PYTHON
  	else if (STRICMP(name, "python") == 0)
  	    n = python_enabled(FALSE);
  #endif
+ #endif
+ #ifdef FEAT_PYTHON3
+ #ifdef DYNAMIC_PYTHON3
+ 	else if (STRICMP(name, "python3") == 0)
+ 	    n = python3_enabled(FALSE);
+ #endif
+ #endif
  #ifdef DYNAMIC_PERL
  	else if (STRICMP(name, "perl") == 0)
  	    n = perl_enabled(FALSE);
diff -caPr ..\vimorg/src/ex_cmds.h ./src/ex_cmds.h
*** ..\vimorg/src/ex_cmds.h	2010-04-19 14:14:44.283986700 +0200
--- ./src/ex_cmds.h	2010-04-19 17:39:53.423088200 +0200
***************
*** 729,734 ****
--- 729,738 ----
  			RANGE|EXTRA|NEEDARG|CMDWIN),
  EX(CMD_pyfile,		"pyfile",	ex_pyfile,
  			RANGE|FILE1|NEEDARG|CMDWIN),
+ EX(CMD_python3,		"py3",	ex_python3,
+ 			RANGE|EXTRA|NEEDARG|CMDWIN),
+ EX(CMD_py3file,		"py3file",	ex_py3file,
+ 			RANGE|FILE1|NEEDARG|CMDWIN),
  EX(CMD_quit,		"quit",		ex_quit,
  			BANG|TRLBAR|CMDWIN),
  EX(CMD_quitall,		"quitall",	ex_quit_all,
diff -caPr ..\vimorg/src/ex_docmd.c ./src/ex_docmd.c
*** ..\vimorg/src/ex_docmd.c	2010-04-19 14:14:44.268369100 +0200
--- ./src/ex_docmd.c	2010-04-19 17:39:53.438708200 +0200
***************
*** 129,135 ****
  static int	check_more __ARGS((int, int));
  static linenr_T get_address __ARGS((char_u **, int skip, int to_other_file));
  static void	get_flags __ARGS((exarg_T *eap));
! #if !defined(FEAT_PERL) || !defined(FEAT_PYTHON) || !defined(FEAT_TCL) \
  	|| !defined(FEAT_RUBY) || !defined(FEAT_MZSCHEME)
  # define HAVE_EX_SCRIPT_NI
  static void	ex_script_ni __ARGS((exarg_T *eap));
--- 129,135 ----
  static int	check_more __ARGS((int, int));
  static linenr_T get_address __ARGS((char_u **, int skip, int to_other_file));
  static void	get_flags __ARGS((exarg_T *eap));
! #if !defined(FEAT_PERL) || !defined(FEAT_PYTHON) || !defined(FEAT_PYTHON3) || !defined(FEAT_TCL) \
  	|| !defined(FEAT_RUBY) || !defined(FEAT_MZSCHEME)
  # define HAVE_EX_SCRIPT_NI
  static void	ex_script_ni __ARGS((exarg_T *eap));
***************
*** 255,260 ****
--- 255,264 ----
  # define ex_python		ex_script_ni
  # define ex_pyfile		ex_ni
  #endif
+ #ifndef FEAT_PYTHON3
+ # define ex_python3		ex_script_ni
+ # define ex_py3file		ex_ni
+ #endif
  #ifndef FEAT_TCL
  # define ex_tcl			ex_script_ni
  # define ex_tcldo		ex_ni
***************
*** 2537,2542 ****
--- 2541,2547 ----
  	    case CMD_perl:
  	    case CMD_psearch:
  	    case CMD_python:
+ 	    case CMD_python3:
  	    case CMD_return:
  	    case CMD_rightbelow:
  	    case CMD_ruby:
***************
*** 2799,2804 ****
--- 2804,2814 ----
      {
  	while (ASCII_ISALPHA(*p))
  	    ++p;
+         //for python 3.x support (:py3)
+         if (STRNCMP(eap->cmd,"py",(size_t)2)==0)
+             while (ASCII_ISALNUM(*p))
+                 ++p;
+                 
  	/* check for non-alpha command */
  	if (p == eap->cmd && vim_strchr((char_u *)"@*!=><&~#", *p) != NULL)
  	    ++p;
diff -caPr ..\vimorg/src/globals.h ./src/globals.h
*** ..\vimorg/src/globals.h	2010-04-19 14:14:45.814511500 +0200
--- ./src/globals.h	2010-04-19 17:39:53.438708200 +0200
***************
*** 1414,1420 ****
  #ifdef FEAT_LIBCALL
  EXTERN char_u e_libcall[]	INIT(= N_("E364: Library call failed for \"%s()\""));
  #endif
! #if defined(DYNAMIC_PERL) || defined(DYNAMIC_PYTHON) || defined(DYNAMIC_RUBY) \
  	|| defined(DYNAMIC_TCL) || defined(DYNAMIC_ICONV) \
  	|| defined(DYNAMIC_GETTEXT) || defined(DYNAMIC_MZSCHEME)
  EXTERN char_u e_loadlib[]	INIT(= N_("E370: Could not load library %s"));
--- 1414,1420 ----
  #ifdef FEAT_LIBCALL
  EXTERN char_u e_libcall[]	INIT(= N_("E364: Library call failed for \"%s()\""));
  #endif
! #if defined(DYNAMIC_PERL) || defined(DYNAMIC_PYTHON) || defined(DYNAMIC_PYTHON3) || defined(DYNAMIC_RUBY) \
  	|| defined(DYNAMIC_TCL) || defined(DYNAMIC_ICONV) \
  	|| defined(DYNAMIC_GETTEXT) || defined(DYNAMIC_MZSCHEME)
  EXTERN char_u e_loadlib[]	INIT(= N_("E370: Could not load library %s"));
diff -caPr ..\vimorg/src/if_python.c ./src/if_python.c
*** ..\vimorg/src/if_python.c	2010-04-19 14:14:44.736897100 +0200
--- ./src/if_python.c	2010-04-19 17:39:53.454328200 +0200
***************
*** 96,101 ****
--- 96,114 ----
  #  define HINSTANCE long_u		/* for generating prototypes */
  # endif
  
+ #ifndef _WIN32
+ #include <dlfcn.h>
+ #define FARPROC void*
+ #define HINSTANCE void*
+ #define load_dll(n) dlopen((n),RTLD_LAZY)
+ #define close_dll dlclose
+ #define symbol_from_dll dlsym
+ #else
+ #define load_dll LoadLibrary
+ #define close_dll FreeLibrary
+ #define symbol_from_dll GetProcAddress
+ #endif
+ 
  /* This makes if_python.c compile without warnings against Python 2.5
   * on Win32 and Win64. */
  #undef PyRun_SimpleString
***************
*** 315,321 ****
  {
      if (hinstPython)
      {
! 	FreeLibrary(hinstPython);
  	hinstPython = 0;
      }
  }
--- 328,334 ----
  {
      if (hinstPython)
      {
! 	close_dll(hinstPython);
  	hinstPython = 0;
      }
  }
***************
*** 332,338 ****
  
      if (hinstPython)
  	return OK;
!     hinstPython = LoadLibrary(libname);
      if (!hinstPython)
      {
  	if (verbose)
--- 345,351 ----
  
      if (hinstPython)
  	return OK;
!     hinstPython = load_dll(libname);
      if (!hinstPython)
      {
  	if (verbose)
***************
*** 342,351 ****
  
      for (i = 0; python_funcname_table[i].ptr; ++i)
      {
! 	if ((*python_funcname_table[i].ptr = GetProcAddress(hinstPython,
  			python_funcname_table[i].name)) == NULL)
  	{
! 	    FreeLibrary(hinstPython);
  	    hinstPython = 0;
  	    if (verbose)
  		EMSG2(_(e_loadfunc), python_funcname_table[i].name);
--- 355,364 ----
  
      for (i = 0; python_funcname_table[i].ptr; ++i)
      {
! 	if ((*python_funcname_table[i].ptr = symbol_from_dll(hinstPython,
  			python_funcname_table[i].name)) == NULL)
  	{
! 	    close_dll(hinstPython);
  	    hinstPython = 0;
  	    if (verbose)
  		EMSG2(_(e_loadfunc), python_funcname_table[i].name);
